/* Regarde un fichier par notification

Affiche une requte qund un fichier est modifi.
USAGE: watch <file>
EXEMPLE: run >NIL: watch >NIL: s:startup-sequence

A besoin de la v37

"regarde" simplement un fichier, en utilisant le nouveau systme
de notification du kick 2.0.
Note : il ne vous prvient pas que le fichier va tre modifi, il
vous le dit juste.
Utile, par exemple, si vous installez un nouveau programme, et vous
voulez savoir ce que fait l'Installer fait quelque chose  votre
startup-sequence ou votre user-startup.

Notez que la seule faon d'arrter Watch est de modifier le fichier
(ou de rebooter :-)

*/

OPT OSVERSION=37

MODULE 'dos/notify'

PROC main()                       /* s'assure que le fichier est l:  */
  DEF nreq:PTR TO notifyrequest,sig,task    /* sinon on n'aura jamais */
  IF (FileLength(arg)=-1) OR (arg[0]=0)     /* de notification        */
    WriteF('file "\s" does not exist\n',arg)
    CleanUp(10)
  ENDIF
  nreq:=New(SIZEOF notifyrequest)     /* mmoire vide */
  IF nreq=NIL THEN RETURN 20
  sig:=AllocSignal(-1)                /* on veux tre prvenu */
  IF sig=-1 THEN RETURN 10
  task:=FindTask(0)
  nreq.name:=arg                      /* rempli dans la structure */
  nreq.flags:=NRF_SEND_SIGNAL
  nreq.port:=task                     /* union port/task */
  nreq.signalnum:=sig
  IF StartNotify(nreq)
    WriteF('Now watching: "\s"\n',arg)
    Wait(Shl(1,sig))
    EasyRequestArgs(0,[20,0,0,'Le fichier "\s" a t modifi!','Zut!'],0,[arg])
    EndNotify(nreq)
  ELSE
    WriteF('Ne peut pas regarder "\s".\n',arg)
  ENDIF
  FreeSignal(sig)
ENDPROC
